﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_subarray_extensions
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private string[] Values1d;
        private string[,] Values2d;

        // Initialize the values.
        private void Form1_Load(object sender, EventArgs e)
        {
            Values1d = new string[5];
            for (int col = 0; col <= Values1d.GetUpperBound(0); col++)
            {
                Values1d[col] = "(" + col.ToString() + ")";
            }

            Values2d = new string[5, 4];
            for (int row = 0; row <= Values2d.GetUpperBound(0); row++)
            {
                for (int col = 0; col <= Values2d.GetUpperBound(1); col++)
                {
                    Values2d[row, col] = "(" + row.ToString() + ", " + col.ToString() + ")";
                }
            }

            // Display the values.
            ShowValues(lstValues1d, Values1d);
            ShowValues(lstValues2d, Values2d);
            ShowValues(lstValues2d2, Values2d);
        }

        // Copy the values and display the result.
        private void btnCopy1d_Click(object sender, EventArgs e)
        {
            string[] new_values = Values1d.SubArray(1, 3);
            ShowValues(lstCopy1d, new_values);
        }

        // Copy the values and display the result.
        private void btnCopy2d_Click(object sender, EventArgs e)
        {
            string[,] new_values = Values2d.SubArray(2, 3, 1, 3);
            ShowValues(lstCopy2d, new_values);
        }

        // Copy the values and display the result.
        private void btnCopy2d2_Click(object sender, EventArgs e)
        {
            // Allocate a new array.
            string[,] new_values = new string[
                Values2d.GetUpperBound(0) + 1,
                Values2d.GetUpperBound(1) + 1];

            // Fill the array with --- values.
            for (int row = 0; row <= new_values.GetUpperBound(0); row++)
            {
                for (int col = 0; col <= new_values.GetUpperBound(1); col++)
                {
                    new_values[row, col] = "------";
                }
            }

            // Copy the values.
            Values2d.CopyTo(new_values, 2, 3, 1, 3, 1, 0);

            // Display the values.
            ShowValues(lstCopy2d2, new_values);
        }

        // Display some values in a ListBox.
        private void ShowValues(ListBox lst, string[,] the_values)
        {
            lst.Items.Clear();
            for (int row = 0; row <= the_values.GetUpperBound(0); row++)
            {
                string str = "";
                for (int col = 0; col <= the_values.GetUpperBound(1); col++)
                {
                    str += the_values[row, col] + " ";
                }
                str = str.Substring(0, str.Length - 1);
                lst.Items.Add(str);
            }
        }

        private void ShowValues(ListBox lst, string[] the_values)
        {
            lst.Items.Clear();
            string str = "";
            for (int col = 0; col <= the_values.GetUpperBound(0); col++)
            {
                str += the_values[col] + " ";
            }
            str = str.Substring(0, str.Length - 1);
            lst.Items.Add(str);
        }
    }
}
